"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var unsafeAssert = require("assert");
var Option_1 = require("fp-ts/lib/Option");
var assert_1 = require("assert");
exports.AssertionError = assert_1.AssertionError;
var tryCatch2 = function (unsafeAssertFn) { return function (value, message) {
    try {
        unsafeAssertFn(value, message);
        return Option_1.none;
    }
    catch (err) {
        return Option_1.some(err);
    }
}; };
var tryCatch3 = function (unsafeAssertFn) { return function (actual, expected, message) {
    try {
        unsafeAssertFn(actual, expected, message);
        return Option_1.none;
    }
    catch (err) {
        return Option_1.some(err);
    }
}; };
exports.assert = tryCatch2(unsafeAssert);
exports.deepEqual = tryCatch3(unsafeAssert.deepEqual);
exports.deepStrictEqual = tryCatch3(unsafeAssert.deepStrictEqual);
exports.equal = tryCatch3(unsafeAssert.equal);
exports.fail = function (message) {
    try {
        unsafeAssert.fail(message);
        // should never reach this
        if (message instanceof Error) {
            throw new unsafeAssert.AssertionError({ message: message.message });
        }
        throw new unsafeAssert.AssertionError({ message: message });
    }
    catch (err) {
        return err;
    }
};
exports.ifError = function (value) {
    try {
        unsafeAssert.ifError(value);
        return Option_1.none;
    }
    catch (err) {
        return Option_1.some(err);
    }
};
exports.notDeepEqual = tryCatch3(unsafeAssert.notDeepEqual);
exports.notDeepStrictEqual = tryCatch3(unsafeAssert.notDeepStrictEqual);
exports.notEqual = tryCatch3(unsafeAssert.notEqual);
exports.notStrictEqual = tryCatch3(unsafeAssert.notStrictEqual);
exports.strictEqual = tryCatch3(unsafeAssert.strictEqual);
exports.throws = function (block, error, message) {
    try {
        unsafeAssert.throws(block, error, message);
        return Option_1.none;
    }
    catch (err) {
        return Option_1.some(err);
    }
};
